GET FILE='F:\TNC Work\ScenesConstruction\YPDataJustin\YPConcatenated.sav'.

SORT CASES BY zip(A).

SELECT IF (YP = 3
| YP = 4
| YP = 5
| YP = 101
| YP = 102
| YP = 108
| YP = 113
| YP = 115
| YP = 116
| YP = 117
| YP = 118
| YP = 122
| YP = 128
| YP = 129
| YP = 130
| YP = 136
| YP = 141
| YP = 145
| YP = 146
| YP = 15 
| YP = 151
| YP = 153
| YP = 156
| YP = 162
| YP = 163
| YP = 169
| YP = 172
| YP = 174
| YP = 175
| YP = 179
| YP = 180
| YP = 182
| YP = 183
| YP = 184
| YP = 188
| YP = 189
| YP = 190
| YP = 191
| YP = 192
| YP = 193
| YP = 197
| YP = 198
| YP = 199
| YP = 200
| YP = 202
| YP = 206
| YP = 209
| YP = 21 
| YP = 213
| YP = 217
| YP = 219
| YP = 220
| YP = 222
| YP = 229
| YP = 234
| YP = 236
| YP = 237
| YP = 238
| YP = 241
| YP = 243
| YP = 244
| YP = 245
| YP = 248
| YP = 249
| YP = 255
| YP = 260
| YP = 262
| YP = 263
| YP = 265
| YP = 266
| YP = 268
| YP = 269
| YP = 274
| YP = 275
| YP = 276
| YP = 277
| YP = 278
| YP = 279
| YP = 283
| YP = 284
| YP = 285
| YP = 286
| YP = 288
| YP = 298
| YP = 301
| YP = 305
| YP = 306
| YP = 308
| YP = 309
| YP = 313
| YP = 34 
| YP = 35 
| YP = 38 
| YP = 43 
| YP = 53 
| YP = 54 
| YP = 56 
| YP = 57 
| YP = 58 
| YP = 59 
| YP = 60 
| YP = 61 
| YP = 62 
| YP = 65 
| YP = 66 
| YP = 70 
| YP = 73 
| YP = 74 
| YP = 75 
| YP = 79 
| YP = 91 
| YP = 99).
EXECUTE.

AGGREGATE
	/OUTFILE=* MODE=ADDVARIABLES
	/BREAK=zip
	/TotRestaurants = SUM(tot_estb)
	/NumTypes = NU(tot_estb).

*Perfect Diversity of restaurants would be equal numbers of each different kind of restaurant.

COMPUTE PerfectDiversity = TotRestaurants/NumTypes.

*The absolute value of the difference is the Deviation, a measure of how far from Perfect Diversity the.
*distribution of one kind of restaurant is. 

COMPUTE Deviation = abs(tot_estb-PerfectDiversity).
EXECUTE.

*Summing the Deviations for each kind of restaurant gives us a measure of LACK of diversity.
*   0 = Perfect Diversity.
*   # = Number of restaurants which would have to change type in order to create perfect diversity.

AGGREGATE
	/OUTFILE=* MODE=ADDVARIABLES
	/BREAK=zip
	/IndexDissimilar2 = SUM(Deviation).

COMPUTE NumNeedToChange = IndexDissimilar/2.
COMPUTE RestUndiversity = (IndexDissimilar2/2)/TotRestaurants.
EXECUTE.
VARIABLE LABEL RestUndiversity 'Number of restaurants which would have to change type in order to produce perfect diversity'.

* Identify Duplicate Cases.
SORT CASES BY zip(A).
MATCH FILES
  /FILE=*
  /BY zip
  /FIRST=PrimaryFirst
  /LAST=PrimaryLast.
DO IF (PrimaryFirst).
COMPUTE  MatchSequence=1-PrimaryLast.
ELSE.
COMPUTE  MatchSequence=MatchSequence+1.
END IF.
LEAVE  MatchSequence.
FORMAT  MatchSequence (f7).
COMPUTE  InDupGrp=MatchSequence>0.
SORT CASES InDupGrp(D).
MATCH FILES
  /FILE=*
  /DROP=PrimaryFirst InDupGrp MatchSequence.
VARIABLE LABELS  PrimaryLast 'Indicator of each last matching case as Primary'.
VALUE LABELS  PrimaryLast 0 'Duplicate Case' 1 'Primary Case'.
VARIABLE LEVEL  PrimaryLast (ORDINAL).
EXECUTE.

FILTER OFF.
USE ALL.
SELECT IF (PrimaryLast=1).
EXECUTE.